=== contrib/testnet/requirements.txt ===
flask
pynacl
