=== debian/changelog ===
lokinet (0.4.2) UNRELEASED; urgency=medium

  * bug fix release

 -- Jeff Becker (probably not evil) <jeff@i2p.rocks>  Sat, 11 May 2019 10:45:49 -0400

lokinet (0.4.1) disco; urgency=medium


  [ Jeff Becker (probably not evil) ]
  * MANDITORY UPGRADE FOR TOYNET (again)
  
  * crypto protocol fixes in utp preventing fragment replaying
  
  * rewrite dns subsystem

  * snode tld resolution to service nodes

  * random.snode CNAME records giving a random service node

  * localhost.loki A and CNAME records for giving IP and Hostnames (respectively) for all locally owned endpoints

  * stability tweaks

  * crash fixes

  * much refactoring

  * such documentation updates

  * many C++ 17 isms

  * very vendor updates

  * wow !

 -- Jeff Becker (probably not evil) <jeff@i2p.rocks>  Sat, 11 May 2019 10:45:46 -0400

lokinet (0.2.3) bionic; urgency=medium

  [ Jeff Becker (probably not evil) ]
  * MANDITORY UPGRADE FOR TOYNET

  * remove iwp and replace with utp

  * use sntrup for introset public key (backwards incompatable)

  * hidden service tags (backwards incompatable)

  * add nicknames to RC (backwards incompatable)

  * change kdf for path keys (backwards incompatable)

  * various dht fixes

  * various dns fixes (still unused in lokinet executable)

  * hidden services should sorta work (no client interfacing code yet)

  * initial win32 port (may sorta work)

  * initial android point (should compile)

  * fix shadow testnet

  * moved netloop and logic into same thread

  * update motto

  * debian packaging

  * windows port

  * cross compile targets

  * continous integration

  * android port

  * android glue code ( will be moved later ) 

  * snap network namespace isolation, untested

  [ jeff ]

  * bump versions

  * add lokinet-bootstrap script

  * dns automapping

  * hidden serivce junk
 
  * systemd unit
  * 0.4.0

 -- jeff <jeff@i2p.rocks>  Thu, 28 Feb 2019 08:44:59 -0500
