=== debian/control ===
Source: lokinet
Section: net
Priority: optional
Maintainer: Jeff Becker (probably not evil) <jeff@i2p.rocks>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.2~), gcc (>= 4.7) | clang (>= 3.3), cmake (>= 3.0), libcap-dev (>= 2.25)
Standards-Version: 3.9.6
Homepage: https://loki.network/
Vcs-Git: git://github.com/loki-project/lokinet-builder.git
Vcs-Browser: https://github.com/loki-project/lokinet-builder

Package: lokinet
Architecture: any
Pre-Depends: adduser
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base, libcap2-bin, curl
Description: Reference implementation for LLARP.
 Lokinet is a private, decentralized and Market based, Sybil
 resistant overlay network for the internet.
 .
 This package contains the reference implementation of LLARP.
